diff -crN nakedmudv1.0/src/olc/exedit.c nakedmudv1.4/src/olc/exedit.c
*** nakedmudv1.0/src/olc/exedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/exedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,254 ----
+ //*****************************************************************************
+ //
+ // exedit.c
+ //
+ // contains all of the functions needed for editing exits.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../exit.h"
+ #include "../socket.h"
+ #include "../utils.h"
+ 
+ #include "olc.h"
+ 
+ 
+ void exedit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   EXIT_DATA *exit = (EXIT_DATA *)olcGetData(olc);
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{g[{c%s{g]\r\n"
+ 		 "{g1) Door name\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Door keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g3) Leave message\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g4) Enter message\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g5) Description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g6) Exits to:   {y[{c%6d{y]\r\n"
+ 		 "{g7) Closable:   {y[{c%6s{y]\r\n"
+ 		 "{g8) Key vnum:   {y[{c%6d{y]\r\n"
+ 		 "{g9) Pick diff:  {y[{c%6d{y]\r\n"
+ 		 "{g0) Spot diff:  {y[{c%6d{y]\r\n"
+ 		 "\r\n"
+ 		 "{gD) Delete exit\r\n"
+ 		 "\r\n"
+ 		 "{gEnter choice (Q to quit) : {n",
+ 		 olcGetArgument(olc),
+ 		 (*exitGetName(exit) ? exitGetName(exit) : "<NONE>"),
+ 		 (*exitGetKeywords(exit) ? exitGetKeywords(exit) : "<NONE>"),
+ 		 (*exitGetSpecLeave(exit) ? exitGetSpecLeave(exit):"<DEFAULT>"),
+ 		 (*exitGetSpecEnter(exit) ? exitGetSpecEnter(exit):"<DEFAULT>"),
+ 		 exitGetDesc(exit),
+ 		 exitGetTo(exit),
+ 		 (exitIsClosable(exit) ? "Yes" : "No" ),
+ 		 exitGetKey(exit),
+ 		 exitGetPickLev(exit),
+ 		 exitGetHidden(exit)
+ 		 );
+ }
+ 
+ 
+ 
+ void exedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = EXEDIT_MAIN;
+   EXIT_DATA *exit = (EXIT_DATA *)olcGetData(olc);
+ 
+   switch(toupper(*arg)) {
+   case 'q':
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = EXEDIT_CONFIRM_SAVE;
+     break;
+ 
+   case 'd':
+   case 'D':
+     send_to_socket(sock, "Are you sure you want to delete this exit (Y/N) : ");
+     next_substate = EXEDIT_CONFIRM_DELETE;
+     break;
+ 
+   case '1':
+     send_to_socket(sock, "Enter new name : ");
+     next_substate = EXEDIT_NAME;
+     break;
+ 
+   case '2':
+     send_to_socket(sock, "Enter new keywords : ");
+     next_substate = EXEDIT_KEYWORDS;
+     break;
+ 
+   case '3':
+     send_to_socket(sock,"Enter new leave message ($n for character's name) : ");
+     next_substate = EXEDIT_LEAVE;
+     break;
+ 
+   case '4':
+     send_to_socket(sock,"Enter new enter message ($n for character's name) : ");
+     next_substate = EXEDIT_ENTER;
+     break;
+ 
+   case '5':
+     send_to_socket(sock, "Enter new description\r\n");
+     start_text_editor(sock,
+ 		      exitGetDescPtr(exit),
+ 		      MAX_BUFFER, EDITOR_MODE_NORMAL);
+     break;
+ 
+   case '6':
+     send_to_socket(sock, "Where does this exit lead to : ");
+     next_substate = EXEDIT_TO;
+     break;
+ 
+   case '7':
+     // just toggle it instead of prompting
+     exitSetClosable(exit, (exitIsClosable(exit) ? FALSE : TRUE));
+     next_substate = EXEDIT_MAIN;
+     // since it's normally assumed we show a prompt, 
+     // we have to redisplay the main menu
+     exedit_menu(sock, olc);
+ 
+     //    send_to_socket(sock, "Is the exit openable and closable (Y/N) : ");
+     //    next_substate = EXEDIT_CLOSABLE;
+     break;
+ 
+   case '8':
+     send_to_socket(sock, "Enter the vnum of the key (-1 for none) : ");
+     next_substate = EXEDIT_KEY;
+     break;
+ 
+   case '9':
+     send_to_socket(sock, "How difficult is the lock to pick : ");
+     next_substate = EXEDIT_PICK_DIFF;
+     break;
+ 
+   case '0':
+     send_to_socket(sock, "How difficult is the exit to spot : ");
+     next_substate = EXEDIT_SPOT_DIFF;
+     break;
+ 
+   default:
+     exedit_menu(sock, olc);
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ 
+ 
+ //
+ // The entry loop for exedit. Figures out what substate we're
+ // in, and then enters into the appropriate subloop if possible,
+ // or sets a value based on arg if there is no subloop
+ //
+ void exedit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   EXIT_DATA *exit = (EXIT_DATA *)olcGetData(olc);
+   int next_substate = EXEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case EXEDIT_MAIN:
+     exedit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case EXEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = EXEDIT_CONFIRM_SAVE;
+       break;
+     }
+ 
+ 
+     /******************************************************/
+     /*                   CONFIRM DELETE                   */
+     /******************************************************/
+   case EXEDIT_CONFIRM_DELETE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetData(olc, NULL);
+       olcSetSave(olc, TRUE);
+       olcSetComplete(olc, TRUE);
+       return;
+     case 'n':
+     case 'N':
+       break;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = EXEDIT_CONFIRM_DELETE;
+       break;
+     }
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case EXEDIT_NAME:
+     exitSetName(exit, arg);
+     break;
+   case EXEDIT_KEYWORDS:
+     exitSetKeywords(exit, arg);
+     break;
+   case EXEDIT_LEAVE:
+     exitSetSpecLeave(exit, arg);
+     break;
+   case EXEDIT_ENTER:
+     exitSetSpecEnter(exit, arg);
+     break;
+   case EXEDIT_TO:
+     exitSetTo(exit, atoi(arg));
+     break;
+   case EXEDIT_SPOT_DIFF:
+     exitSetHidden(exit, MAX(0, atoi(arg)));
+     break;
+   case EXEDIT_PICK_DIFF:
+     exitSetPickLev(exit, MAX(0, atoi(arg)));
+     break;
+   case EXEDIT_KEY:
+     exitSetKey(exit, MAX(-1, atoi(arg)));
+     break;
+     /*
+      * closable is now just toggled when
+      * we choose to edit its closable status
+      *
+   case EXEDIT_CLOSABLE:
+     exitSetClosable(exit, (toupper(*arg) == 'Y'));
+     break;
+     */
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing redit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == EXEDIT_MAIN)
+     exedit_menu(sock, olc);
+ }
diff -crN nakedmudv1.0/src/olc/medit.c nakedmudv1.4/src/olc/medit.c
*** nakedmudv1.0/src/olc/medit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/medit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,260 ----
+ //*****************************************************************************
+ //
+ // medit.c
+ //
+ // Contains all of the functions needed for online editing of mobiles.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../world.h"
+ #include "../character.h"
+ #include "../socket.h"
+ #include "../utils.h"
+ #include "../races.h"
+ #include "../dialog.h"
+ 
+ #include "olc.h"
+ 
+ #ifdef MODULE_SCRIPTS
+ #include "../scripts/script_set.h"
+ #include "../scripts/script.h"
+ #endif
+ 
+ 
+ void medit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   CHAR_DATA *mob = (CHAR_DATA *)olcGetData(olc);
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{g[{c%d{g]\r\n"
+ 		 "{g1) Name\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Name for multiple occurances\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g3) Keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g4) Room description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g5) Room description for multiple occurances\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g6) Description\r\n"
+ 		 "{c%s\r\n"
+ #ifdef MODULE_SCRIPTS
+ 		 "{gS) Script menu\r\n"
+ #endif
+ 		 "{gR) Change race  {y[{c%8s{y]\r\n"
+ 		 "{gD) Dialog       {y[{c%8d{y]  {w%s\r\n",
+ 		 charGetVnum(mob),
+ 		 charGetName(mob),
+ 		 charGetMultiName(mob),
+ 		 charGetKeywords(mob),
+ 		 charGetRdesc(mob),
+ 		 charGetMultiRdesc(mob),
+ 		 charGetDesc(mob),
+ 		 raceGetName(charGetRace(mob)),
+ 		 charGetDialog(mob),
+ 		 (worldGetDialog(gameworld, charGetDialog(mob)) ?
+ 		  dialogGetName(worldGetDialog(gameworld, 
+ 					       charGetDialog(mob))) : "")
+ 		 );
+ 
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "{gEnter choice (Q to quit) : {n"
+ 		 );
+ }
+ 
+ void medit_race_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   int i;
+   for(i = 0; i < NUM_RACES; i++)
+     send_to_socket(sock, "%2d) %-20s%s", 
+ 		   i, raceGetName(i), (i % 3 == 2 ?"\r\n":""));
+   if(i % 3 != 0)
+     send_to_socket(sock, "\r\n");
+   send_to_socket(sock,
+ 		 "\r\nPlease select a race: ");
+ }
+ 
+ void medit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = MEDIT_MAIN;
+ 
+   switch(*arg) {
+   case 'q':
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = MEDIT_CONFIRM_SAVE;
+     break;
+ 
+   case '1':
+     send_to_socket(sock, "Enter name : ");
+     next_substate = MEDIT_NAME;
+     break;
+ 
+   case '2':
+     send_to_socket(sock, "Enter name for multiple occurances : ");
+     next_substate = MEDIT_MULTI_NAME;
+     break;
+ 
+   case '3':
+     send_to_socket(sock, "Enter keywords : ");
+     next_substate = MEDIT_KEYWORDS;
+     break;
+ 
+   case '4':
+     send_to_socket(sock, "Enter room description : ");
+     next_substate = MEDIT_RDESC;
+     break;
+ 
+   case '5':
+     send_to_socket(sock, "Enter room description for multiple occurances : ");
+     next_substate = MEDIT_MULTI_RDESC;
+     break;
+ 
+   case '6':
+     send_to_socket(sock, "Enter description\r\n");
+     start_text_editor(sock, 
+ 		      charGetDescPtr((CHAR_DATA *)olcGetData(olc)),
+ 		      MAX_BUFFER, EDITOR_MODE_NORMAL);
+     next_substate = MEDIT_MAIN;
+     break;
+ 
+   case 'r':
+   case 'R':
+     medit_race_menu(sock, olc);
+     next_substate = MEDIT_RACE;
+     break;
+ 
+   case 'd':
+   case 'D':
+     send_to_socket(sock, "Enter new dialog vnum (-1 for none) : ");
+     next_substate = MEDIT_DIALOG;
+     break;
+ 
+ #ifdef MODULE_SCRIPTS
+   case 's':
+   case 'S':
+     olcSetNext(olc, newOLC(OLC_SSEDIT, SSEDIT_MAIN,
+ 			   copyScriptSet(charGetScripts((CHAR_DATA *)olcGetData(olc))), charGetName((CHAR_DATA *)olcGetData(olc))));
+     next_substate = MEDIT_SCRIPTS;
+     break;
+ #endif
+ 
+   default:
+     medit_menu(sock, olc);
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ 
+ void medit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   CHAR_DATA *mob = (CHAR_DATA *)olcGetData(olc);
+   int next_substate = MEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case MEDIT_MAIN:
+     medit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case MEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = MEDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case MEDIT_NAME:
+     charSetName(mob, arg);
+     break;
+ 
+   case MEDIT_MULTI_NAME:
+     charSetMultiName(mob, arg);
+     break;
+ 
+   case MEDIT_KEYWORDS:
+     charSetKeywords(mob, arg);
+     break;
+ 
+   case MEDIT_RDESC:
+     charSetRdesc(mob, arg);
+     break;
+ 
+   case MEDIT_MULTI_RDESC:
+     charSetMultiRdesc(mob, arg);
+     break;
+ 
+   case MEDIT_RACE: {
+     int race = RACE_NONE;
+     if(isdigit(*arg)) race = atoi(arg);
+     else              race = raceGetNum(arg);
+     if(race == RACE_NONE) {
+       send_to_socket(sock, "Invalid race! Try again: ");
+       next_substate = MEDIT_RACE;
+     }
+     else {
+       charSetRace(mob, race);
+       charResetBody(mob);
+     }
+     break;
+   }
+ 
+   case MEDIT_DIALOG: {
+     int vnum = (*arg ? atoi(arg) : NOTHING);
+     DIALOG_DATA *dialog = worldGetDialog(gameworld, vnum);
+     if(dialog || vnum == NOTHING)
+       charSetDialog(mob, vnum);
+     next_substate = MEDIT_MAIN;
+     break;
+   }
+ 
+ #ifdef MODULE_SCRIPTS
+   case MEDIT_SCRIPTS:
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       SCRIPT_SET *scripts = (SCRIPT_SET *)olcGetData(olcGetNext(olc));
+       charSetScripts(mob, (scripts ? copyScriptSet(scripts) : newScriptSet()));
+     }
+     olcSetNext(olc, NULL);
+     next_substate = MEDIT_MAIN;
+     break;
+ #endif
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing medit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == MEDIT_MAIN)
+     medit_menu(sock, olc);
+ }
diff -crN nakedmudv1.0/src/olc/module.mk nakedmudv1.4/src/olc/module.mk
*** nakedmudv1.0/src/olc/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/module.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ # source files we contain
+ SRC  += olc/dedit.c olc/edesc_edit.c olc/exedit.c olc/medit.c olc/oedit.c \
+ 	olc/redit.c olc/zedit.c olc/ssedit.c olc/scedit.c olc/resedit.c \
+ 	olc/socedit.c olc/olc.c
diff -crN nakedmudv1.0/src/olc/oedit.c nakedmudv1.4/src/olc/oedit.c
*** nakedmudv1.0/src/olc/oedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/oedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,519 ----
+ //*****************************************************************************
+ //
+ // oedit.c
+ //
+ // Contains all of the functions needed for online editing of objects.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../world.h"
+ #include "../object.h"
+ #include "../extra_descs.h"
+ #include "../socket.h"
+ #include "../utils.h"
+ #include "../body.h"
+ #include "../items.h"
+ 
+ #include "olc.h"
+ 
+ #ifdef MODULE_SCRIPTS
+ #include "../scripts/script_set.h"
+ #include "../scripts/script.h"
+ #endif
+ 
+ 
+ //
+ // a quick little utility to assert that a number is within a given
+ // range (max inclusive, min not). If it isn't, make sure the next 
+ // state we go to is the same one we're currently in.
+ //
+ #define ASSERT_VAL_RANGE(num, min, max)                     \
+   if(num < min || num > max) {                              \
+     oedit_val_menu(sock, olc, olcGetSubstate(olc));         \
+     next_substate = olcGetSubstate(olc);                    \
+   }                                                         \
+   else {                                                    \
+     objSetVal(obj, olcGetSubstate(olc) - OEDIT_VAL_0, num); \
+     next_substate = olcGetSubstate(olc) + 1;                \
+     if(next_substate > OEDIT_VAL_0 + NUM_OBJ_VALUES)        \
+       next_substate = OEDIT_MAIN;                           \
+   }
+ 
+ 
+ void oedit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   OBJ_DATA *obj = (OBJ_DATA *)olcGetData(olc);
+   char bitbuf[SMALL_BUFFER] = "";
+   char valbuf[MAX_BUFFER] = "";
+   int i;
+ 
+   for(i = 0; i < NUM_OBJ_VALUES; i++)
+     sprintf(valbuf, "%s%d ", valbuf, objGetVal(obj, i));
+ 
+   objPrintBits(obj, BITFIELD_OBJ, bitbuf);
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{g[{c%d{g]\r\n"
+ 		 "{g1) Name\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Name for multiple occurances\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g3) Keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g4) Room description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g5) Room description for multiple occurances\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g6) Description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{gW) Weight:    {c%1.3lf\r\n"
+ 		 "{gC) Capacity:  {c%1.3lf\r\n"
+ 		 "{gB) Edit bits: {c%s\r\n"
+ 		 "{gX) Extra Descriptions menu\r\n"
+ #ifdef MODULE_SCRIPTS
+ 		 "{gS) Script menu\r\n"
+ #endif
+ 		 "{gT)    Type: {c%s\r\n"
+ 		 "{g   Subtype: {c%s\r\n"
+ 		 "{g    Values: {c%s\r\n",
+ 		 objGetVnum(obj),
+ 		 objGetName(obj),
+ 		 objGetMultiName(obj),
+ 		 objGetKeywords(obj),
+ 		 objGetRdesc(obj),
+ 		 objGetMultiRdesc(obj),
+ 		 objGetDesc(obj),
+ 		 objGetWeightRaw(obj),
+ 		 objGetCapacity(obj),
+ 		 bitbuf,
+ 		 itemGetType(objGetType(obj)),
+ 		 (numItemSubtypes(objGetType(obj)) > 0 ?
+ 		  itemGetSubtype(objGetType(obj), objGetSubtype(obj)) : "none"),
+ 		 valbuf
+ 		 );
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "{gEnter choice (Q to quit) : {n"
+ 		 );
+ }
+ 
+ 
+ //
+ // lists all of the item types available
+ //
+ void show_item_type_menu(SOCKET_DATA *sock) {
+   int i;
+ 
+   send_to_socket(sock, "Item types:\r\n");
+   for(i = 0; i < NUM_ITEM_TYPES; i++)
+     send_to_socket(sock, "{c%4d{g) %-14s%s",
+ 		   i, itemGetType(i), (i % 3 == 2 ? "\r\n" : "    "));
+   if(i % 3 != 0)
+     send_to_socket(sock, "\r\n");
+ 
+   send_to_socket(sock, "\r\nEnter your choice: ");
+ }
+ 
+ 
+ //
+ // lists all of the subtypes of a particular item type
+ //
+ void show_item_subtype_menu(SOCKET_DATA *sock, int type) {
+   int i;
+   int num_subtypes = numItemSubtypes(type);
+ 
+   if(num_subtypes == 0)
+     return;
+   send_to_socket(sock, "Item subtypes:\r\n");
+   for(i = 0; i < num_subtypes; i++)
+     send_to_socket(sock, "{c%4d{g) %-14s%s",
+ 		   i, itemGetSubtype(type, i), (i % 3 == 2 ? "\r\n" : "    "));
+   if(i % 3 != 0)
+     send_to_socket(sock, "\r\n");
+   send_to_socket(sock, "\r\nEnter your choice: ");
+ }
+ 
+ 
+ //
+ // Show all of the bits
+ //
+ void show_obj_bits(SOCKET_DATA *sock, OLC_DATA *olc) {
+   OBJ_DATA *obj = olcGetData(olc);
+   char buf[SMALL_BUFFER];
+   int i = 0;
+   
+   send_to_socket(sock, CLEAR_SCREEN);
+   for(i = 0; i < NUM_OBJ_BITS; i++)
+     send_to_socket(sock, "{c%4d{g) %-14s%s",
+ 		   i, objBitGetName(BITFIELD_OBJ, i), 
+ 		   (i % 3 == 2 ? "\r\n" : "    "));
+   if(i % 3 != 0)
+     send_to_socket(sock, "\r\n");
+ 
+   objPrintBits(obj, BITFIELD_OBJ, buf);
+   send_to_socket(sock, 
+ 		 "\r\n"
+ 		 "Current bits: {c%s{g\r\n"
+ 		 "Enter your choice (Q to quit) : ", buf);
+ }
+ 
+ 
+ //
+ // Returns the state that we should be in right now, if we're trying
+ // to edit an olc value with editing state olc_state
+ //
+ int oedit_val_menu(SOCKET_DATA *sock, OLC_DATA *olc, int olc_state) {
+   int type = objGetType((OBJ_DATA *)olcGetData(olc));
+   switch(olc_state) {
+     /*************/
+     /* OBJ VAL 0 */
+     /*************/
+   case OEDIT_VAL_0:
+     switch(type) {
+     case ITEM_PORTAL:
+       send_to_socket(sock, "Enter a destination (-1, 1000000) : ");
+       break;
+     case ITEM_FURNITURE:
+       send_to_socket(sock, "What is the seating capacity (1, 100) : ");
+       break;
+     case ITEM_CONTAINER:
+       send_to_socket(sock, "Is the container closable (0 = no, 1 = yes) : ");
+       break;
+     default: 
+       return oedit_val_menu(sock, olc, olc_state+1);
+     }
+     break;
+ 
+ 
+     /*************/
+     /* OBJ VAL 1 */
+     /*************/
+   case OEDIT_VAL_1:
+     switch(type) {
+     case ITEM_CONTAINER:
+       send_to_socket(sock, "What is the key vnum (-1 for none) : ");
+       break;
+     default: 
+       return oedit_val_menu(sock, olc, olc_state+1);
+     }
+     break;
+ 
+ 
+     /*************/
+     /* OBJ VAL 2 */
+     /*************/
+   case OEDIT_VAL_2:
+     switch(type) {
+     case ITEM_CONTAINER:
+       send_to_socket(sock, "What is the lock picking difficulty : ");
+       break;
+     default: 
+       return oedit_val_menu(sock, olc, olc_state+1);
+     }
+     break;
+ 
+ 
+     /*************/
+     /* OBJ VAL 3 */
+     /*************/
+   case OEDIT_VAL_3:
+     switch(type) {
+     default: 
+       return oedit_val_menu(sock, olc, olc_state+1);
+     }
+     break;
+ 
+   default: 
+     oedit_menu(sock, olc);
+     return OEDIT_MAIN;
+   }
+ 
+   // this is reached when we've actually printed a prompt
+   return olc_state;
+ }
+ 
+ 
+ 
+ void oedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = OEDIT_MAIN;
+ 
+   switch(toupper(*arg)) {
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = OEDIT_CONFIRM_SAVE;
+     break;
+ 
+   case '1':
+     send_to_socket(sock, "Enter name : ");
+     next_substate = OEDIT_NAME;
+     break;
+ 
+   case '2':
+     send_to_socket(sock, "Enter name for multiple occurances : ");
+     next_substate = OEDIT_MULTI_NAME;
+     break;
+ 
+   case '3':
+     send_to_socket(sock, "Enter keywords : ");
+     next_substate = OEDIT_KEYWORDS;
+     break;
+ 
+   case '4':
+     send_to_socket(sock, "Enter room description : ");
+     next_substate = OEDIT_RDESC;
+     break;
+ 
+   case '5':
+     send_to_socket(sock, "Enter room description for multiple occurances : ");
+     next_substate = OEDIT_MULTI_RDESC;
+     break;
+ 
+   case '6':
+     send_to_socket(sock, "Enter description\r\n");
+     start_text_editor(sock, 
+ 		      objGetDescPtr((OBJ_DATA *)olcGetData(olc)),
+ 		      MAX_BUFFER, EDITOR_MODE_NORMAL);
+     next_substate = OEDIT_MAIN;
+     break;
+ 
+   case 'W':
+     send_to_socket(sock, "Enter new weight : ");
+     next_substate = OEDIT_WEIGHT;
+     break;
+ 
+   case 'C':
+     send_to_socket(sock, "Enter new carrying capacity : ");
+     next_substate = OEDIT_CAPACITY;
+     break;
+ 
+   case 'B':
+     show_obj_bits(sock, olc);
+     next_substate = OEDIT_BITS;
+     break;
+ 
+   case 'X':
+     olcSetNext(olc, newOLC(OLC_EDSEDIT, EDSEDIT_MAIN, 
+ 			   copyEdescSet(objGetEdescs((OBJ_DATA *)olcGetData(olc))), NULL));
+     next_substate = OEDIT_EDESCS;
+     break;
+ 
+ #ifdef MODULE_SCRIPTS
+   case 'S':
+     olcSetNext(olc, newOLC(OLC_SSEDIT, SSEDIT_MAIN,
+ 			   copyScriptSet(objGetScripts((OBJ_DATA *)olcGetData(olc))), objGetName((OBJ_DATA *)olcGetData(olc))));
+     next_substate = OEDIT_SCRIPTS;
+     break;
+ #endif
+ 
+   case 'T':
+     show_item_type_menu(sock);
+     next_substate = OEDIT_TYPE;
+     break;
+ 
+   default:
+     oedit_menu(sock, olc);
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ 
+ void oedit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   OBJ_DATA *obj = (OBJ_DATA *)olcGetData(olc);
+   int next_substate = OEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case OEDIT_MAIN:
+     oedit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case OEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = OEDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case OEDIT_NAME:
+     objSetName(obj, arg);
+     break;
+ 
+   case OEDIT_MULTI_NAME:
+     objSetMultiName(obj, arg);
+     break;
+ 
+   case OEDIT_KEYWORDS:
+     objSetKeywords(obj, arg);
+     break;
+ 
+   case OEDIT_RDESC:
+     objSetRdesc(obj, arg);
+     break;
+ 
+   case OEDIT_MULTI_RDESC:
+     objSetMultiRdesc(obj, arg);
+     break;
+ 
+   case OEDIT_WEIGHT:
+     objSetWeightRaw(obj, atof(arg));
+     break;
+ 
+   case OEDIT_CAPACITY:
+     objSetCapacity(obj, atof(arg));
+     break;
+ 
+   case OEDIT_EDESCS:
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       EDESC_SET *edescs = (EDESC_SET *)olcGetData(olcGetNext(olc));
+       objSetEdescs(obj, (edescs ? copyEdescSet(edescs) : newEdescSet()));
+     }
+ 
+     olcSetNext(olc, NULL);
+     next_substate = OEDIT_MAIN;
+     break;
+ 
+ #ifdef MODULE_SCRIPTS
+   case OEDIT_SCRIPTS:
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       SCRIPT_SET *scripts = (SCRIPT_SET *)olcGetData(olcGetNext(olc));
+       objSetScripts(obj, (scripts ? copyScriptSet(scripts) : newScriptSet()));
+     }
+     olcSetNext(olc, NULL);
+     next_substate = OEDIT_MAIN;
+     break;
+ #endif
+ 
+   case OEDIT_BITS:
+     if(toupper(*arg) == 'Q')
+       next_substate = OEDIT_MAIN;
+     else {
+       int bit = atoi(arg);
+       if(bit >= 0 && bit < NUM_OBJ_BITS)
+ 	objToggleBit(obj, BITFIELD_OBJ, bit);
+       next_substate = OEDIT_BITS;
+     }
+     break;
+ 
+   case OEDIT_TYPE: {
+     int num = atoi(arg);
+     if(num < 0 || num >= NUM_ITEM_TYPES) {
+       show_item_type_menu(sock);
+       next_substate = OEDIT_TYPE;
+     }
+     else {
+       // if we're not of the same type, reset all of our values
+       if(num != objGetType(obj)) {
+ 	int i;
+ 	for(i = 0; i < NUM_OBJ_VALUES; i++)
+ 	  objSetVal(obj, i, 0);
+       }
+ 
+       objSetType(obj, num);
+       if(numItemSubtypes(num) > 0) {
+ 	show_item_subtype_menu(sock, num);
+ 	next_substate = OEDIT_SUBTYPE;
+       }
+       else
+ 	next_substate = OEDIT_VAL_0;
+     }
+     break;
+   }
+ 
+   case OEDIT_SUBTYPE: {
+     int num = atoi(arg);
+     if(num < 0 || num >= numItemSubtypes(objGetType(obj))) {
+       show_item_subtype_menu(sock, objGetType(obj));
+       next_substate = OEDIT_SUBTYPE;
+     }
+     else {
+       objSetSubtype(obj, num);
+       next_substate = OEDIT_VAL_0;
+     }
+     break;
+   }
+ 
+   case OEDIT_VAL_0:
+     switch(objGetType(obj)) {
+     case ITEM_PORTAL:    ASSERT_VAL_RANGE(atoi(arg), -1, 1000000);  break;
+     case ITEM_FURNITURE: ASSERT_VAL_RANGE(atoi(arg), -1, 100);      break;
+     case ITEM_CONTAINER: ASSERT_VAL_RANGE(atoi(arg),  0, 1);        break;
+     default: break;
+     }
+     next_substate = OEDIT_VAL_1;
+     break;
+ 
+   case OEDIT_VAL_1:
+     switch(objGetType(obj)) {
+     case ITEM_CONTAINER: ASSERT_VAL_RANGE(atoi(arg), -1, 1000000); break;
+     default: break;
+     }
+     next_substate = OEDIT_VAL_2;
+     break;
+ 
+   case OEDIT_VAL_2:
+     switch(objGetType(obj)) {
+     case ITEM_CONTAINER: ASSERT_VAL_RANGE(atoi(arg), 0, 1000000); break;
+     default: break;
+     }
+     next_substate = OEDIT_VAL_3;
+     break;
+ 
+   case OEDIT_VAL_3:
+     switch(objGetType(obj)) {
+     default: break;
+     }
+     next_substate = OEDIT_MAIN;
+     break;
+ 
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing oedit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+ 
+   /********************************************************/
+   /*                 DISPLAY NEXT MENU HERE               */
+   /********************************************************/
+   if(next_substate == OEDIT_MAIN)
+     oedit_menu(sock, olc);
+   else if(next_substate >= OEDIT_VAL_0 && 
+ 	  next_substate <  OEDIT_VAL_0 + NUM_OBJ_VALUES)
+     next_substate = oedit_val_menu(sock, olc, next_substate);
+   else if(next_substate == OEDIT_BITS)
+     show_obj_bits(sock, olc);
+ 
+   olcSetSubstate(olc, next_substate);
+ }
